package test.a1;

import com.threed.jpct.GenericVertexController;
import com.threed.jpct.IVertexController;
import com.threed.jpct.Object3D;
import com.threed.jpct.Primitives;
import com.threed.jpct.SimpleVector;

/**
 * 
 * @author  hakan eryargi (r a f t)
 */
public class AnimatedObject extends Object3D {
	
	private SimpleVector[] sourceMesh;
	private SimpleVector[] destMesh;
	
	private final VertexController vertexController = new VertexController();
	
	private float offset = 0f;
	private int direction = 1;
	
	public AnimatedObject() {
		super(Primitives.getBox(1, 1));
		attachVertexController();
	}
	
	public void animatePose(float seconds) {
		offset += seconds * direction;
		if (offset > 1) {
			offset = 1;
			direction = -1;
		} else if (offset < 0) {
			offset = 0;
			direction = 1;
		}
		
		destMesh[0].y = sourceMesh[0].y + offset;
		vertexController.updateMesh();
	}
	
	private void attachVertexController() {
		// we call calcNormals here to avoid warning setting vertex controller on an object with no normals 
		calcNormals();
		getMesh().setVertexController(vertexController, IVertexController.PRESERVE_SOURCE_MESH);
		
		if (sourceMesh == null) {
			sourceMesh = vertexController.getSourceMesh();
			destMesh = vertexController.getDestinationMesh();
		}
	}
	
	/** we just use this to get mesh data */
	private class VertexController extends GenericVertexController {
		private static final long serialVersionUID = 1L;
		
		public void apply() {
		}
	}
}
