package tmp;

import com.threed.jpct.*;

import javax.swing.*;

/**
 * A simple HelloWorld using the Software-renderer and rendering into a frame
 * using active rendering.
 * @author EgonOlsen
 * 
 */
public class HelloWorldSoftware {

	private World world;
	private FrameBuffer buffer;
	private JFrame frame;
	
	private AnimatedObject object = new AnimatedObject();

	public static void main(String[] args) throws Exception {
		new HelloWorldSoftware().loop();
	}

	public HelloWorldSoftware() throws Exception {
		
		frame=new JFrame("Hello world");
		frame.setSize(800, 600);
		frame.setVisible(true);
		frame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		
		world = new World();

		object.build();
		world.addObject(object);
		world.setAmbientLight(255, 255, 255);
		
		world.getCamera().moveCamera(Camera.CAMERA_MOVEOUT, 8f);
	}

	private void loop() throws Exception {
		buffer = new FrameBuffer(800, 600, FrameBuffer.SAMPLINGMODE_NORMAL);

		while (frame.isShowing()) {
			float seconds = 0.1f;
			object.animatePose(seconds);
			
			buffer.clear(java.awt.Color.BLUE);
			world.renderScene(buffer);
			world.draw(buffer);
			buffer.update();
			buffer.display(frame.getGraphics());
			Thread.sleep(10);
		}
		buffer.disableRenderer(IRenderer.RENDERER_OPENGL);
		buffer.dispose();
		frame.dispose();
		System.exit(0);
	}
}

	